#ifndef _FADE_SCREEN_EFFECT_H_
#define _FADE_SCREEN_EFFECT_H_

#include <OgreRectangle2D.h>
#include <OgreSceneNode.h>
#include <OgreRoot.h>
#include <OgreMaterialManager.h>
#include <OgreOverlayManager.h>
#include <OgreOverlay.h>
#include <OgreOverlayContainer.h>

class FadeScreenEffect
{
    public:
        FadeScreenEffect(Ogre::Root* root, const Ogre::String& name="Overlays/FadeInOut", const Ogre::String& mat="Basic/BlackAlpha");
        virtual ~FadeScreenEffect();
        Ogre::Overlay* getOverlay();
        void setSpeed(float speed) { mSpeed = speed; }
        float getSpeed() { return mSpeed; }
        void setScreenViewTime(int t) { mTimeAfterFade = t; }
        void setIn() { mInOut = 1.f; }
        void setOut() { mInOut = -1.f; }
        void fade();
        bool fade1frame();
        void hide();

        static void csleep(int ms);

    protected:
        Ogre::Root* mRoot;
        float mAlpha;
        float mSpeed;
        float mInOut;
        int mTimeAfterFade;
        Ogre::Overlay* mOverlay;
        Ogre::Material* mMat;
        Ogre::TextureUnitState* mTextUS;

};

#endif // _FADE_SCREEN_EFFECT_H_
