#include "LangConfig.h"

LangConfig::LangConfig(const Ogre::String& lang)
{
    mFile.load(lang);

    mValue["font"] = mFile.getSetting("font", "fonts");
    bool right2left = Ogre::StringConverter::parseBool(mFile.getSetting("righttoleft", "fonts"));

    Ogre::ConfigFile::SectionIterator seci = mFile.getSectionIterator();
    while (seci.hasMoreElements())
    {
        Ogre::String secName = seci.peekNextKey();
        Ogre::ConfigFile::SettingsMultiMap *settings = seci.getNext();
        Ogre::ConfigFile::SettingsMultiMap::iterator i;
        for (i = settings->begin(); i != settings->end(); ++i)
        {
            Ogre::String key = i->first;
            Ogre::DisplayString val = i->second;
            if(right2left && secName=="lang")
            {
                val = rightToLeft(val);
            }
            mValue[key] = val;
        }
    }


}

LangConfig::~LangConfig()
{
    //dtor
}

Ogre::DisplayString LangConfig::rightToLeft(const Ogre::DisplayString& str)
{
    Ogre::DisplayString rls;
    for(int i=str.size()-1; i>=0; i--)
    {
        rls.push_back(str[i]);
    }
    return rls;
}

Ogre::String& LangConfig::getFont(const Ogre::String& name)
{
    return mValue[name];
}
