#ifndef _LOADER_H_
#define _LOADER_H_

#include <Edge.h>
#include <Ogre.h>
#include "CVehicle.h"
#include "Track.h"
#include <Util.h>

class Loader
{
    public:
        static edge::ai::Path* loadPath(const Ogre::String& str);
        static CVehicle* loadVehicle(edge::World* m_world, const Ogre::String& cfg_path, int& id, bool reflection);
        static void loadVehicleList(Ogre::StringVector& cfgFileList);
        static Track* loadTrack(edge::World* m_world, const Ogre::String& cfgFile);
        static void loadTrackList(Ogre::String& cfgFileList);

    protected:
        Loader();
};

#endif // _LOADER_H_
