#include "Track.h"

Track::Track(edge::Body* body)
: m_body(body)
{
    //ctor
}

Track::~Track()
{
    for(int i=0; i<m_path.size(); i++)
        delete m_path[i];
}

void Track::setFinishLine(const Ogre::Vector3& pos, float _a, float _b, float _c, float _r)
{
    mPos = pos;
    a = _a;
    b = _b;
    c = _c;
    r = _r;
}

bool Track::testDistance(const Ogre::Vector3& pos)
{
    if(mPos.distance(pos) <= r)
        return true;
    return false;
}

float Track::getPointToFinish(const Ogre::Vector3& point)
{
    return a * point.x + b * point.z + c;
}
